# Linked Data Modeling Language: Specification

Authors:

 - Chris Mungall, Lawrence Berkeley National Laboratory 
 - Harold Solbrig, Johns Hopkins University

## Abstract

The Linked Data Modeling Language (LinkML) is a language for writing schemas that describe the structure of *instance* data. A LinkML schema consists of a number of different elements, including *classes*, which are used to type instances, and *slots* which are used to describe instance data attributes.

The LinkML specification defines the structure of instance data using a functional-style syntax, and defines the elements of a schema, together with the rules for operating over these schemas.

## Notes

More information about LinkML can be found on the [LinkML site](https://linkml.io), which includes introductory material and [tutorials](https://linkml.io/linkml/intro/tutorial).
It also includes a reference implementation and set of tools for working with LinkML schemas and data.

The specification provided here is intended to be independent of any particular tool or implementation.

### Status of this specification

This is a draft specification open from comments to all.

### License

This specification, like all parts of LinkML are in the public domain under a Creative Commons Zero license waiver.

